commit 8ac2f3ce09c23fda8cc4657805648a07a210a885
Author: Richard Sandiford <richard.sandiford@arm.com>
Date:   Thu Oct 31 19:52:46 2024 +0000

    aarch64: Forbid F64MM permutes in streaming mode
    
    The current code was based on an early version of the SME spec,
    which allowed the .Q forms of TRN1, TRN2, UZP1, UZP2, ZIP1, and ZIP2
    to be used in streaming mode.  We should now forbid them instead;
    see https://developer.arm.com/documentation/ddi0602/2024-09/SVE-Instructions/TRN1--TRN2--vectors---Interleave-even-or-odd-elements-from-two-vectors-?lang=en
    and the corresponding entries for the others.
    
    gcc/
            * config/aarch64/aarch64-sve-builtins-base.def (svtrn1q, svtrn2q)
            (svuzp1q, svuzp2q, svzip1q, svzip2q): Require SM_OFF.
    
    gcc/testsuite/
            * g++.target/aarch64/sve/aarch64-ssve.exp: Add tests for trn[12]q,
            uzp[12].c, and zip[12]q.
            * gcc.target/aarch64/sve/acle/asm/trn1q_bf16.c: Skip for
            STREAMING_COMPATIBLE.
            * gcc.target/aarch64/sve/acle/asm/trn1q_f16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_f32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_f64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_s16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_s32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_s64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_s8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_u16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_u32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_u64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn1q_u8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_bf16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_f16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_f32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_f64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_s16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_s32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_s64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_s8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_u16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_u32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_u64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/trn2q_u8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_bf16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_f16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_f32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_f64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_s16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_s32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_s64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_s8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_u16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_u32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_u64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp1q_u8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_bf16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_f16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_f32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_f64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_s16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_s32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_s64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_s8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_u16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_u32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_u64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/uzp2q_u8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_bf16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_f16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_f32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_f64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_s16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_s32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_s64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_s8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_u16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_u32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_u64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip1q_u8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_bf16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_f16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_f32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_f64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_s16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_s32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_s64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_s8.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_u16.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_u32.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_u64.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/zip2q_u8.c: Likewise.
    
    (cherry picked from commit e8fa15ea01439bccf15ae9b9a4d63ac92586c2c5)

diff --git a/gcc/config/aarch64/aarch64-sve-builtins-base.def b/gcc/config/aarch64/aarch64-sve-builtins-base.def
index 65fcba91586..e69ca398658 100644
--- a/gcc/config/aarch64/aarch64-sve-builtins-base.def
+++ b/gcc/config/aarch64/aarch64-sve-builtins-base.def
@@ -364,7 +364,11 @@ DEF_SVE_FUNCTION (svusmmla, ternary_uintq_intq, s_signed, none)
 DEF_SVE_FUNCTION (svmmla, mmla, s_float, none)
 #undef REQUIRED_EXTENSIONS
 
-#define REQUIRED_EXTENSIONS AARCH64_FL_SVE | AARCH64_FL_F64MM
+#define REQUIRED_EXTENSIONS (AARCH64_FL_SVE \
+			     | AARCH64_FL_F64MM \
+			     | AARCH64_FL_SM_OFF)
+DEF_SVE_FUNCTION (svld1ro, load_replicate, all_data, implicit)
+DEF_SVE_FUNCTION (svmmla, mmla, d_float, none)
 DEF_SVE_FUNCTION (svtrn1q, binary, all_data, none)
 DEF_SVE_FUNCTION (svtrn2q, binary, all_data, none)
 DEF_SVE_FUNCTION (svuzp1q, binary, all_data, none)
@@ -372,10 +376,3 @@ DEF_SVE_FUNCTION (svuzp2q, binary, all_data, none)
 DEF_SVE_FUNCTION (svzip1q, binary, all_data, none)
 DEF_SVE_FUNCTION (svzip2q, binary, all_data, none)
 #undef REQUIRED_EXTENSIONS
-
-#define REQUIRED_EXTENSIONS (AARCH64_FL_SVE \
-			     | AARCH64_FL_F64MM \
-			     | AARCH64_FL_SM_OFF)
-DEF_SVE_FUNCTION (svld1ro, load_replicate, all_data, implicit)
-DEF_SVE_FUNCTION (svmmla, mmla, d_float, none)
-#undef REQUIRED_EXTENSIONS
diff --git a/gcc/testsuite/g++.target/aarch64/sve/aarch64-ssve.exp b/gcc/testsuite/g++.target/aarch64/sve/aarch64-ssve.exp
index 23ba15a4dba..c92a266f4d1 100644
--- a/gcc/testsuite/g++.target/aarch64/sve/aarch64-ssve.exp
+++ b/gcc/testsuite/g++.target/aarch64/sve/aarch64-ssve.exp
@@ -301,7 +301,13 @@ set nonstreaming_only {
     svstnt1w_scatter_offset (pred, u64, 1, u64)
     svstnt1_scatter_offset (pred, u32_ptr, u32, u32)
     svstnt1_scatter_offset (pred, u32, 1, u32)
+    u8 = svtrn1q (u8, u8)
+    u8 = svtrn2q (u8, u8)
     u32 = svmmla (u32, u8, u8)
+    u8 = svuzp1q (u8, u8)
+    u8 = svuzp2q (u8, u8)
+    u8 = svzip1q (u8, u8)
+    u8 = svzip2q (u8, u8)
     s32 = svusmmla (s32, u8, s8)
     svwrffr (pred)
 }
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_bf16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_bf16.c
index f1810da9ec4..a85734a94fb 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_bf16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_bf16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f16.c
index 6420d0f0aca..045a9a75ea6 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f32.c
index 6fb2eecf5d8..286bcdee3a2 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f64.c
index e786a8d049b..abfa5818631 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_f64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s16.c
index 548360719a6..92912aac010 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s32.c
index ccb8319f7ab..0d5a17eb203 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s64.c
index fe8125a8a16..e3142b3c827 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s8.c
index 48040c1ad36..71ef5b0342a 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_s8.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u16.c
index 3657f919eed..fef20681594 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u32.c
index cc5ea2878ca..84156895fc4 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u64.c
index 4435b53d03e..61b6483abeb 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u8.c
index 4ebfedbea5f..829c92008e3 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn1q_u8.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_bf16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_bf16.c
index 5623b54f035..e01deee6653 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_bf16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_bf16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f16.c
index db219092978..837f3783f35 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f32.c
index 1367a1e0680..11076cd8375 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f64.c
index 54325e705ea..6c849de9cae 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_f64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s16.c
index a0b6412783d..ba97cd7ca08 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s32.c
index 7c128c6effc..671998352e2 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s64.c
index f22222525b9..118469c480e 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s8.c
index bd5243f35ce..d65449f7a6b 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_s8.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u16.c
index 8da8563b201..cfd6a2840d0 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u32.c
index 6c0af02da8f..17f172d351e 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u64.c
index 857595cbbf2..2377de48b12 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u8.c
index 1fb85b249f7..d898ee16c77 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/trn2q_u8.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_bf16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_bf16.c
index 30a19924167..28097e1dbb6 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_bf16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_bf16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f16.c
index c11e5bdc46b..f238b34e297 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f32.c
index d0ac94543d0..4c01d5fd4c1 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f64.c
index ac2e5c5cf14..59aacca1445 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_f64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s16.c
index aa200b24ea5..057d0d1f1d7 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s32.c
index eb849df74bb..3802e1b19bc 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s64.c
index e1049761caf..ffe8be203f5 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s8.c
index 8aa5921992a..f81e038c554 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_s8.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u16.c
index 00ffaab06d6..13db57ee9b9 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u32.c
index cd2e4db26b3..8a12c274054 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u64.c
index 7d8823329a2..6f198158ba1 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u8.c
index 701a1d5751c..0d0d99b8524 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp1q_u8.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_bf16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_bf16.c
index bbac53a7acb..d889e3eef4d 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_bf16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_bf16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f16.c
index e19d118fb83..246350849f9 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f32.c
index af7112b150d..257f703fc9e 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f64.c
index 4109b843cc7..c987aae728f 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_f64.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_s16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_s16.c
index 0c6ab25cf99..f9ff09f0364 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_s16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_s16.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_s32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_s32.c
index 9b914e704a6..d4ad34905a5 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_s32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/uzp2q_s32.c
@@ -1,3 +1,4 @@
+/* { dg-skip-if "" { *-*-* } { "-DSTREAMING_COMPATIBLE" } { "" } } */
 /* { dg-require-effective-target aarch64_asm_f64mm_ok } */
 /* { dg-additional-options "-march=armv8.2-a+f64mm" } */
 /* { dg-final { check-function-bodies "**" "" "-DCHECK_ASM" } } */
